-- phpMyAdmin SQL Dump
-- version 4.8.5
-- https://www.phpmyadmin.net/
--
-- Host: db
-- Generation Time: 01. Apr, 2019 13:05 PM
-- Tjener-versjon: 10.3.13-MariaDB-1:10.3.13+maria~bionic
-- PHP Version: 7.2.14

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET AUTOCOMMIT = 0;
START TRANSACTION;


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;

--
-- Database: `appdb`
--

DELIMITER $$
--
-- Prosedyrer
--

DELIMITER $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `get_login_details_by_email`
(
  IN `email` VARCHAR(80)
)
    READS SQL DATA
BEGIN
	SELECT EXISTS(SELECT email FROM ContactDetails c WHERE email = c.email);
  SELECT u.user_id, u.user_type, u.password, u.two_factor_enabled FROM User u
    INNER JOIN ContactDetails c ON c.user_id = u.user_id WHERE email = c.email;
END$$
DELIMITER ;

DELIMITER $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `get_login_details_by_social_num`
(
  IN `birthdate` date,
  IN `social_num` char(5)
)
    READS SQL DATA
BEGIN
	SELECT EXISTS(SELECT birthdate FROM ContactDetails c WHERE birthdate = c.birthdate)
     AND EXISTS(SELECT social_num FROM ContactDetails c WHERE social_num = c.social_num);
  SELECT u.user_id, u.user_type, u.password, u.two_factor_enabled FROM User u
    INNER JOIN ContactDetails c ON c.user_id = u.user_id
    WHERE birthdate = c.birthdate AND social_num = c.social_num;
END$$
DELIMITER ;

DELIMITER $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `create_user`
(
  IN `password` VARCHAR(100),
  IN `user_type` TINYINT(4),
  IN `first_name` VARCHAR(50),
  IN `last_name` VARCHAR(50),
  IN `email` VARCHAR(80),
  IN `phone_num` CHAR(8),
  IN `birthdate` DATE,
  IN `social_num` CHAR(5),
  IN `invitation_code` VARCHAR(20)
)
    MODIFIES SQL DATA
BEGIN
  DECLARE organization_id int(10) UNSIGNED;

  IF EXISTS(SELECT 'True' FROM ContactDetails c WHERE email = c.email) THEN
    SIGNAL SQLSTATE '23515'
    SET MESSAGE_TEXT = 'EmailExists';
  END IF;

  IF user_type = 1 OR user_type = 2 THEN
    SET organization_id = (SELECT ic.organization_id FROM InvitationCode ic
                  INNER JOIN Organization o ON ic.organization_id = o.organization_id
                  WHERE ic.code = invitation_code AND o.organization_type = 'Team');
    IF organization_id IS NULL THEN
      SIGNAL SQLSTATE '45000' SET MESSAGE_TEXT = 'InvitationCodeWrong';
    END IF;

  ELSEIF user_type = 3 THEN
    SET organization_id = (SELECT ic.organization_id FROM InvitationCode ic
                  INNER JOIN Organization o ON ic.organization_id = o.organization_id
                  WHERE ic.code = invitation_code AND o.organization_type = 'Health');
    IF organization_id IS NULL THEN
      SIGNAL SQLSTATE '45000' SET MESSAGE_TEXT = 'InvitationCodeWrong';
    END IF;
  END IF;

	IF EXISTS(SELECT 'True' FROM ContactDetails c WHERE social_num = c.social_num AND birthdate = c.birthdate) THEN
		SIGNAL SQLSTATE '23515'
		SET MESSAGE_TEXT = 'SocialNumExists';
	END IF;

	INSERT INTO User
    (password,
    user_type,
    first_name,
    last_name)
    VALUES (
			password,
			user_type,
			first_name,
			last_name
            );
	INSERT INTO ContactDetails
	VALUES (
			LAST_INSERT_ID(),
			email,
			phone_num,
			birthdate,
			social_num
            );

	IF user_type = 1 THEN
		INSERT INTO Athlete (athlete_id, team_id)
		VALUES (LAST_INSERT_ID(), organization_id);
    INSERT INTO AthleteStatus (athlete_id)
    VALUES (LAST_INSERT_ID());

    ELSEIF user_type = 2 THEN
		INSERT INTO TeamRepresentative (team_representative_id, team_id)
		VALUES (LAST_INSERT_ID(), organization_id);

    ELSEIF user_type = 3 THEN
		INSERT INTO HealthProfessional (health_professional_id, organization_id)
		VALUES (LAST_INSERT_ID(), organization_id);

    END IF;
END$$
DELIMITER ;

DELIMITER $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `create_club`
(
  IN `b_reg` int(9),
  IN `name` varchar(80),
  IN `address` varchar(50),
  IN `city` varchar(50),
  IN `zip_code` int(4),
  IN `state` enum('Finnmark','Troms','Nordland','Trøndelag','Møre og Romsdal','Sogn og Fjordane','Hordaland','Rogaland','Vest-Agder','Aust-Agder','Telemark','Buskerud','Vestfold','Oslo','Akershus','Østfold','Oppland','Hedmark'),
  IN `phone_num` char(8),
  IN `invitation_code` varchar(20)
)
    MODIFIES SQL DATA
BEGIN
  INSERT INTO Organization (organization_type) VALUES ('Club');
  INSERT INTO Club (club_id, b_reg, name, address, city, zip_code, state, phone_num) VALUES (LAST_INSERT_ID(), b_reg, name, address, city, zip_code, state, phone_num);
  INSERT INTO InvitationCode (code, organization_id) VALUES (invitation_code, LAST_INSERT_ID());
END$$
DELIMITER ;

DELIMITER $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `create_health_organization`
(
  IN `b_reg` int(9),
  IN `name` varchar(80),
  IN `address` varchar(50),
  IN `city` varchar(50),
  IN `zip_code` int(4),
  IN `state` enum('Finnmark','Troms','Nordland','Trøndelag','Møre og Romsdal','Sogn og Fjordane','Hordaland','Rogaland','Vest-Agder','Aust-Agder','Telemark','Buskerud','Vestfold','Oslo','Akershus','Østfold','Oppland','Hedmark'),
  IN `phone_num` char(8),
  IN `invitation_code` varchar(20)
)
    MODIFIES SQL DATA
BEGIN
  INSERT INTO Organization (organization_type) VALUES ('Health');
  INSERT INTO HealthOrganization (organization_id, b_reg, name, address, city, zip_code, state, phone_num) VALUES (LAST_INSERT_ID(), b_reg, name, address, city, zip_code, state, phone_num);
  INSERT INTO InvitationCode (code, organization_id) VALUES (invitation_code, LAST_INSERT_ID());
END$$
DELIMITER ;

DELIMITER $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `create_team`
(
  IN `name` varchar(50),
  IN `club_id` int(10),
  IN `invitation_code` varchar(20)
)
    MODIFIES SQL DATA
BEGIN
  INSERT INTO Organization (organization_type) VALUES ('Team');
  INSERT INTO Team (team_id, club_id, name) VALUES (LAST_INSERT_ID(), club_id, name);
  INSERT INTO InvitationCode (code, organization_id) VALUES (invitation_code, LAST_INSERT_ID());
END$$
DELIMITER ;

DROP PROCEDURE IF EXISTS add_new_message_athlete;
DELIMITER $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `add_new_message_athlete`
(
  IN `user_id_from` int(10),
  IN `message` varchar(500),
  IN `inbox_id` int(10)
)
    MODIFIES SQL DATA

BEGIN
  DECLARE lastInsertMessageId int(10);
  DECLARE userId int(10);
  DECLARE done INT DEFAULT FALSE;
  DECLARE cursorForUnreadMessages CURSOR FOR SELECT u.user_id FROM User u
    INNER JOIN HealthProfessional hp ON u.user_id=hp.health_professional_id
    INNER JOIN Contract c ON hp.organization_id=c.health_organization_id
    INNER JOIN Athlete a ON c.team_id=a.team_id
    WHERE a.athlete_id=inbox_id AND hp.health_professional_id<>user_id_from
    UNION
    SELECT u.user_id FROM User u
    INNER JOIN Athlete a ON u.user_id=a.athlete_id
    WHERE a.athlete_id=inbox_id AND a.athlete_id<>user_id_from;
  DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = TRUE;

  INSERT INTO Message (user_id_from, user_id_to, message, dateOfMessage) VALUES (
    (SELECT user_id FROM User WHERE user_id=user_id_from),
    (SELECT user_id FROM User WHERE user_id=inbox_id), message, NOW());

  SET lastInsertMessageId = LAST_INSERT_ID();

  OPEN cursorForUnreadMessages;

  read_loop: LOOP
    FETCH cursorForUnreadMessages INTO userId;
    IF done THEN
      LEAVE read_loop;
    END IF;

    INSERT INTO UserUnreadMessage (user_id, message_id) VALUES ((SELECT user_id FROM User WHERE user_id=userId), (SELECT message_id FROM Message WHERE message_id=lastInsertMessageId));
  END LOOP;

  CLOSE cursorForUnreadMessages;

  SELECT m.message_id, u.first_name, u.last_name FROM Message m
  INNER JOIN User u ON m.user_id_from=u.user_id
  WHERE message_id=lastInsertMessageId;

END$$
DELIMITER ;


DROP PROCEDURE IF EXISTS add_new_message_injury;
DELIMITER $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `add_new_message_injury`
(
  IN `user_id_from` int(10),
  IN `message` varchar(500),
  IN `inbox_id` int(10)
)
    MODIFIES SQL DATA

BEGIN
  DECLARE lastInsertMessageId int(10);
  DECLARE userId int(10);
  DECLARE done INT DEFAULT FALSE;
  DECLARE cursorForUnreadMessages CURSOR FOR SELECT u.user_id FROM User u
    INNER JOIN HealthProfessional hp ON u.user_id=hp.health_professional_id
    INNER JOIN Contract c ON hp.organization_id=c.health_organization_id
    INNER JOIN Athlete a ON c.team_id=a.team_id
    INNER JOIN Injury i ON a.athlete_id=i.athlete_id
    WHERE i.injury_id=inbox_id AND hp.health_professional_id<>user_id_from
    UNION
    SELECT u.user_id FROM User u
    INNER JOIN Injury i ON u.user_id=i.athlete_id
    WHERE i.injury_id=inbox_id AND i.athlete_id<>user_id_from;
  DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = TRUE;

  INSERT INTO Message (user_id_from, inbox_injury_id, message, dateOfMessage) VALUES (
    (SELECT user_id FROM User WHERE user_id=user_id_from),
    (SELECT injury_id FROM Injury WHERE injury_id=inbox_id), message, NOW());

  SET lastInsertMessageId = LAST_INSERT_ID();

  OPEN cursorForUnreadMessages;

  read_loop: LOOP
    FETCH cursorForUnreadMessages INTO userId;
    IF done THEN
      LEAVE read_loop;
    END IF;

    INSERT INTO UserUnreadMessage (user_id, message_id) VALUES ((SELECT user_id FROM User WHERE user_id=userId), (SELECT message_id FROM Message WHERE message_id=lastInsertMessageId));
  END LOOP;

  CLOSE cursorForUnreadMessages;

  SELECT m.message_id, u.first_name, u.last_name FROM Message m
  INNER JOIN User u ON m.user_id_from=u.user_id
  WHERE message_id=lastInsertMessageId;

END$$
DELIMITER ;

-- --------------------------------------------------------

--
-- Tabellstruktur for tabell `Athlete`
--

CREATE TABLE `Athlete` (
  `athlete_id` int(10) UNSIGNED NOT NULL,
  `team_id` int(10) UNSIGNED DEFAULT NULL,
  `position` varchar(50) COLLATE utf8mb4_danish_ci DEFAULT NULL,
  `shirt_no` int(1) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_danish_ci;

-- --------------------------------------------------------

--
-- Tabellstruktur for tabell `AthleteStatus`
--

CREATE TABLE `AthleteStatus` (
  `athlete_id` int(10) UNSIGNED NOT NULL,
  `summary` varchar(200) COLLATE utf8mb4_danish_ci DEFAULT NULL,
  `status` enum('0','1','2','3','4') COLLATE utf8mb4_danish_ci DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_danish_ci;

-- --------------------------------------------------------

--
-- Tabellstruktur for tabell `Club`
--

CREATE TABLE `Club` (
  `club_id` int(10) UNSIGNED NOT NULL,
  `b_reg` int(9) UNSIGNED NOT NULL,
  `name` varchar(80) COLLATE utf8mb4_danish_ci NOT NULL,
  `address` varchar(50) COLLATE utf8mb4_danish_ci NOT NULL,
  `city` varchar(50) COLLATE utf8mb4_danish_ci NOT NULL,
  `zip_code` int(4) UNSIGNED NOT NULL,
  `state` enum('Finnmark','Troms','Nordland','Trøndelag','Møre og Romsdal','Sogn og Fjordane','Hordaland','Rogaland','Vest-Agder','Aust-Agder','Telemark','Buskerud','Vestfold','Oslo','Akershus','Østfold','Oppland','Hedmark') COLLATE utf8mb4_danish_ci NOT NULL,
  `phone_num` char(8) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_danish_ci;

-- --------------------------------------------------------

--
-- Tabellstruktur for tabell `ContactDetails`
--

CREATE TABLE `ContactDetails` (
  `user_id` int(10) UNSIGNED NOT NULL,
  `email` varchar(80) COLLATE utf8mb4_danish_ci NOT NULL,
  `phone_num` char(8) COLLATE utf8mb4_danish_ci NOT NULL,
  `birthdate` date NOT NULL,
  `social_num` char(5) COLLATE utf8mb4_danish_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_danish_ci;

-- --------------------------------------------------------

--
-- Tabellstruktur for tabell `Contract`
--

CREATE TABLE `Contract` (
  `health_organization_id` int(10) UNSIGNED NOT NULL,
  `team_id` int(10) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_danish_ci;

-- --------------------------------------------------------

--
-- Tabellstruktur for tabell `HealthOrganization`
--

CREATE TABLE `HealthOrganization` (
  `organization_id` int(10) UNSIGNED NOT NULL,
  `b_reg` int(9) UNSIGNED NOT NULL,
  `name` varchar(50) COLLATE utf8mb4_danish_ci NOT NULL,
  `address` varchar(50) COLLATE utf8mb4_danish_ci NOT NULL,
  `city` varchar(50) COLLATE utf8mb4_danish_ci NOT NULL,
  `zip_code` int(4) UNSIGNED NOT NULL,
  `state` enum('Finnmark','Troms','Nordland','Trøndelag','Møre og Romsdal','Sogn og Fjordane','Hordaland','Rogaland','Vest-Agder','Aust-Agder','Telemark','Buskerud','Vestfold','Oslo','Akershus','Østfold','Oppland','Hedmark') COLLATE utf8mb4_danish_ci NOT NULL,
  `phone_num` char(8) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_danish_ci;

-- --------------------------------------------------------

--
-- Tabellstruktur for tabell `HealthProfessional`
--

CREATE TABLE `HealthProfessional` (
  `health_professional_id` int(10) UNSIGNED NOT NULL,
  `organization_id` int(10) UNSIGNED DEFAULT NULL,
  `profession_type` varchar(50) COLLATE utf8mb4_danish_ci DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_danish_ci;

-- --------------------------------------------------------

--
-- Tabellstruktur for tabell `Injury`
--

CREATE TABLE `Injury` (
  `injury_id` int(10) UNSIGNED NOT NULL,
  `athlete_id` int(10) UNSIGNED NOT NULL,
  `title` varchar(30) COLLATE utf8mb4_danish_ci NOT NULL,
  `description` varchar(250) COLLATE utf8mb4_danish_ci DEFAULT NULL,
  `date_registered` date NOT NULL,
  `date_injury` date DEFAULT NULL,
  `date_recovered` date DEFAULT NULL,
  `archived` tinyint(1) DEFAULT 0
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_danish_ci;

-- --------------------------------------------------------

--
-- Tabellstruktur for tabell `InvitationCode`
--

CREATE TABLE `InvitationCode` (
  `code` varchar(20) COLLATE utf8mb4_danish_ci NOT NULL,
  `organization_id` int(10) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_danish_ci;

-- --------------------------------------------------------

--
-- Tabellstruktur for tabell `Message`
--

CREATE TABLE `Message` (
  `message_id` int(10) UNSIGNED NOT NULL,
  `user_id_to` int(10) UNSIGNED,
  `user_id_from` int(10) UNSIGNED NOT NULL,
  `inbox_injury_id` int(10) UNSIGNED,
  `message` varchar(500) COLLATE utf8mb4_danish_ci NOT NULL,
  `dateOfMessage` datetime NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_danish_ci;

-- --------------------------------------------------------

--
-- Tabellstruktur for tabell `Organization`
--

CREATE TABLE `Organization` (
  `organization_id` int(10) UNSIGNED NOT NULL,
  `organization_type` enum('Club', 'Health', 'Team') COLLATE utf8mb4_danish_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_danish_ci;

-- --------------------------------------------------------

--
-- Tabellstruktur for tabell `Status`
--

CREATE TABLE `Status` (
  `status_id` enum('0','1','2','3','4') COLLATE utf8mb4_danish_ci NOT NULL,
  `description` varchar(50) COLLATE utf8mb4_danish_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_danish_ci ROW_FORMAT=COMPACT;

--
-- Dataark for tabell `Status`
--

INSERT INTO `Status` (`status_id`, `description`) VALUES
('0', 'Skadefri'),
('1', 'Lett skade. Kan trene og kamp'),
('2', 'Skadet. Kan trene, ikke kamp'),
('3', 'Skadet. Egentrening, ikke kamp'),
('4', 'Ikke utredet');

-- --------------------------------------------------------

--
-- Tabellstruktur for tabell `Team`
--

CREATE TABLE `Team` (
  `team_id` int(10) UNSIGNED NOT NULL,
  `club_id` int(10) UNSIGNED DEFAULT NULL,
  `name` varchar(50) COLLATE utf8mb4_danish_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_danish_ci;

-- --------------------------------------------------------

--
-- Tabellstruktur for tabell `TeamRepresentative`
--

CREATE TABLE `TeamRepresentative` (
  `team_representative_id` int(10) UNSIGNED NOT NULL,
  `team_id` int(10) UNSIGNED DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_danish_ci;

-- --------------------------------------------------------

--
-- Tabellstruktur for tabell `Token`
--

CREATE TABLE `Token` (
  `token_id` int(10) UNSIGNED NOT NULL,
  `user_id` int(10) UNSIGNED NOT NULL,
  `token` varchar(255) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_danish_ci;

-- --------------------------------------------------------

--
-- Tabellstruktur for tabell `TreatmentPlan`
--

CREATE TABLE `TreatmentPlan` (
  `treatment_id` int(10) UNSIGNED NOT NULL,
  `injury_id` int(10) UNSIGNED NOT NULL,
  `health_professional` int(10) UNSIGNED DEFAULT NULL,
  `date_start` date NOT NULL,
  `date_end` date DEFAULT NULL,
  `instructions` varchar(500) COLLATE utf8mb4_danish_ci NOT NULL,
  `medications` varchar(250) COLLATE utf8mb4_danish_ci DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_danish_ci ROW_FORMAT=COMPACT;

-- --------------------------------------------------------

--
-- Tabellstruktur for tabell `User`
--

CREATE TABLE `User` (
  `user_id` int(10) UNSIGNED NOT NULL,
  `password` varchar(100) COLLATE utf8mb4_danish_ci NOT NULL,
  `user_type` tinyint(1) UNSIGNED NOT NULL,
  `first_name` varchar(50) COLLATE utf8mb4_danish_ci NOT NULL,
  `last_name` varchar(50) COLLATE utf8mb4_danish_ci NOT NULL,
  `two_factor_secret` varchar(55) DEFAULT NULL,
  `two_factor_enabled` tinyint(1) DEFAULT 0
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_danish_ci ROW_FORMAT=COMPACT;

-- --------------------------------------------------------

--
-- Tabellstruktur for tabell `UserType`
--

CREATE TABLE `UserType` (
  `user_type_id` enum('1','2','3','4') COLLATE utf8mb4_danish_ci NOT NULL,
  `name` varchar(50) COLLATE utf8mb4_danish_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_danish_ci;

-- --------------------------------------------------------

--
-- Tabellstruktur for tabell `UserUnreadMessage`
--

CREATE TABLE `UserUnreadMessage` (
  `user_id` int(10) UNSIGNED NOT NULL,
  `message_id` int(10) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_danish_ci;

--
-- Dataark for tabell `UserType`
--

INSERT INTO `UserType` (`user_type_id`, `name`) VALUES
('1', 'Utøver'),
('2', 'Klubbrepresentant'),
('3', 'Helsepersonell'),
('4', 'Administrator');

--
-- Indexes for dumped tables
--

--
-- Indexes for table `Athlete`
--
ALTER TABLE `Athlete`
  ADD PRIMARY KEY (`athlete_id`),
  ADD KEY `ath_team_id_idx` (`team_id`);

--
-- Indexes for table `AthleteStatus`
--
ALTER TABLE `AthleteStatus`
  ADD PRIMARY KEY (`athlete_id`),
  ADD KEY `id` (`athlete_id`),
  ADD KEY `status_id_idx` (`status`);

--
-- Indexes for table `Club`
--
ALTER TABLE `Club`
  ADD PRIMARY KEY (`club_id`),
  ADD UNIQUE KEY `b_reg` (`b_reg`);

--
-- Indexes for table `ContactDetails`
--
ALTER TABLE `ContactDetails`
  ADD PRIMARY KEY (`user_id`),
  ADD UNIQUE KEY `email_UNIQUE` (`email`),
  ADD UNIQUE KEY `social_num_UNIQUE` (`birthdate`, `social_num`);

--
-- Indexes for table `Contract`
--
ALTER TABLE `Contract`
  ADD PRIMARY KEY (`health_organization_id`, `team_id`),
  ADD KEY `health_organization_id_idx` (`health_organization_id`),
  ADD KEY `team_id_idx` (`team_id`);

--
-- Indexes for table `HealthOrganization`
--
ALTER TABLE `HealthOrganization`
  ADD PRIMARY KEY (`organization_id`),
  ADD UNIQUE KEY `b_reg` (`b_reg`);

--
-- Indexes for table `HealthProfessional`
--
ALTER TABLE `HealthProfessional`
  ADD PRIMARY KEY (`health_professional_id`),
  ADD KEY `health_professional_id_idx` (`health_professional_id`),
  ADD KEY `health_organization_id_idx` (`organization_id`);

--
-- Indexes for table `Injury`
--
ALTER TABLE `Injury`
  ADD PRIMARY KEY (`injury_id`),
  ADD KEY `athlete_id_idx` (`athlete_id`);

--
-- Indexes for table `Status`
--
ALTER TABLE `Status`
  ADD PRIMARY KEY (`status_id`);

--
-- Indexes for table `InvitationCode`
--
ALTER TABLE `InvitationCode`
  ADD PRIMARY KEY (`code`),
  ADD KEY `code_organization_idx` (`organization_id`);

--
-- Indexes for table `Message`
--
ALTER TABLE `Message`
  ADD PRIMARY KEY (`message_id`),
  ADD KEY `id_from_idx` (`user_id_from`),
  ADD KEY `id_to_idx` (`user_id_to`),
  ADD KEY `inbox_id_idx` (`inbox_injury_id`);

--
-- Indexes for table `Organization`
--
ALTER TABLE `Organization`
  ADD PRIMARY KEY (`organization_id`);

--
-- Indexes for table `Team`
--
ALTER TABLE `Team`
  ADD PRIMARY KEY (`team_id`),
  ADD KEY `club_id_idx` (`club_id`);

--
-- Indexes for table `TeamRepresentative`
--
ALTER TABLE `TeamRepresentative`
  ADD PRIMARY KEY (`team_representative_id`),
  ADD KEY `team_id_idx` (`team_id`);

--
-- Indexes for table `Token`
--
ALTER TABLE `Token`
  ADD PRIMARY KEY (`token_id`),
  ADD KEY `id_user_idx` (`user_id`),
  ADD UNIQUE KEY `token_UNIQUE` (`user_id`, `token`);

--
-- Indexes for table `TreatmentPlan`
--
ALTER TABLE `TreatmentPlan`
  ADD PRIMARY KEY (`treatment_id`),
  ADD KEY `injury_id` (`injury_id`),
  ADD KEY `health_professional_id_idx` (`health_professional`);

--
-- Indexes for table `User`
--
ALTER TABLE `User`
  ADD PRIMARY KEY (`user_id`),
  ADD KEY `user_type_idx` (`user_type`);

--
-- Indexes for table `UserType`
--
ALTER TABLE `UserType`
  ADD PRIMARY KEY (`user_type_id`);

--
-- Indexes for table `UserUnreadMessage`
--
ALTER TABLE `UserUnreadMessage`
  ADD KEY `user_unread_id_idx` (`user_id`),
  ADD KEY `message_unread_id_idx` (`message_id`),
  ADD UNIQUE KEY `UserUnreadMessage_UNIQUE` (`user_id`, `message_id`);

--
-- AUTO_INCREMENT for dumped tables
--

--
-- AUTO_INCREMENT for table `Injury`
--
ALTER TABLE `Injury`
  MODIFY `injury_id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `Message`
--
ALTER TABLE `Message`
  MODIFY `message_id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `Organization`
--
ALTER TABLE `Organization`
  MODIFY `organization_id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `Token`
--
ALTER TABLE `Token`
  MODIFY `token_id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `TreatmentPlan`
--
ALTER TABLE `TreatmentPlan`
  MODIFY `treatment_id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `User`
--
ALTER TABLE `User`
  MODIFY `user_id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT;

--
-- Begrensninger for dumpede tabeller
--

--
-- Begrensninger for tabell `Athlete`
--
ALTER TABLE `Athlete`
  ADD CONSTRAINT `athlete_id` FOREIGN KEY (`athlete_id`) REFERENCES `User` (`user_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `ath_team_id` FOREIGN KEY (`team_id`) REFERENCES `Team` (`team_id`) ON UPDATE CASCADE;

--
-- Begrensninger for tabell `AthleteStatus`
--
ALTER TABLE `AthleteStatus`
  ADD CONSTRAINT `athlete_status_id` FOREIGN KEY (`athlete_id`) REFERENCES `Athlete` (`athlete_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `status_id` FOREIGN KEY (`status`) REFERENCES `Status` (`status_id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Begrensninger for tabell `Club`
--
ALTER TABLE `Club`
  ADD CONSTRAINT `club_org_id` FOREIGN KEY (`club_id`) REFERENCES `Organization` (`organization_id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Begrensninger for tabell `ContactDetails`
--
ALTER TABLE `ContactDetails`
  ADD CONSTRAINT `user_contact_id` FOREIGN KEY (`user_id`) REFERENCES `User` (`user_id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Begrensninger for tabell `Contract`
--
ALTER TABLE `Contract`
  ADD CONSTRAINT `contract_health_org_id` FOREIGN KEY (`health_organization_id`) REFERENCES `HealthOrganization` (`organization_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `contract_team_id` FOREIGN KEY (`team_id`) REFERENCES `Team` (`team_id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Begrensninger for tabell `HealthOrganization`
--
ALTER TABLE `HealthOrganization`
  ADD CONSTRAINT `health_org_id` FOREIGN KEY (`organization_id`) REFERENCES `Organization` (`organization_id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Begrensninger for tabell `HealthProfessional`
--
ALTER TABLE `HealthProfessional`
  ADD CONSTRAINT `health_organization_id` FOREIGN KEY (`organization_id`) REFERENCES `HealthOrganization` (`organization_id`) ON UPDATE CASCADE,
  ADD CONSTRAINT `health_professional_id` FOREIGN KEY (`health_professional_id`) REFERENCES `User` (`user_id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Begrensninger for tabell `Injury`
--
ALTER TABLE `Injury`
  ADD CONSTRAINT `injury_athlete_id` FOREIGN KEY (`athlete_id`) REFERENCES `Athlete` (`athlete_id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Begrensninger for tabell `InvitationCode`
--
ALTER TABLE `InvitationCode`
  ADD CONSTRAINT `code_org_id` FOREIGN KEY (`organization_id`) REFERENCES `Organization` (`organization_id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Begrensninger for tabell `Message`
--
ALTER TABLE `Message`
  ADD CONSTRAINT `id_from` FOREIGN KEY (`user_id_from`) REFERENCES `User` (`user_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `id_to` FOREIGN KEY (`user_id_to`) REFERENCES `User` (`user_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `inbox_id` FOREIGN KEY (`inbox_injury_id`) REFERENCES `Injury` (`injury_id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Begrensninger for tabell `Team`
--
ALTER TABLE `Team`
  ADD CONSTRAINT `team_org_id` FOREIGN KEY (`team_id`) REFERENCES `Organization` (`organization_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `club_id` FOREIGN KEY (`club_id`) REFERENCES `Club` (`club_id`) ON UPDATE CASCADE;

--
-- Begrensninger for tabell `TeamRepresentative`
--
ALTER TABLE `TeamRepresentative`
  ADD CONSTRAINT `team_id` FOREIGN KEY (`team_id`) REFERENCES `Team` (`team_id`) ON UPDATE CASCADE,
  ADD CONSTRAINT `team_representative_id` FOREIGN KEY (`team_representative_id`) REFERENCES `User` (`user_id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Begrensninger for tabell `Token`
--
ALTER TABLE `Token`
  ADD CONSTRAINT `user_id` FOREIGN KEY (`user_id`) REFERENCES `User` (`user_id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Begrensninger for tabell `TreatmentPlan`
--
ALTER TABLE `TreatmentPlan`
  ADD CONSTRAINT `health_professional` FOREIGN KEY (`health_professional`) REFERENCES `HealthProfessional` (`health_professional_id`) ON DELETE SET NULL ON UPDATE CASCADE,
  ADD CONSTRAINT `injury_id` FOREIGN KEY (`injury_id`) REFERENCES `Injury` (`injury_id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Begrensninger for tabell `User`
--
ALTER TABLE `User`
  ADD CONSTRAINT `user_type` FOREIGN KEY (`user_type`) REFERENCES `UserType` (`user_type_id`);

--
-- Begrensninger for tabell `UserUnreadMessage`
--
ALTER TABLE `UserUnreadMessage`
  ADD CONSTRAINT `user_unread_id` FOREIGN KEY (`user_id`) REFERENCES `User` (`user_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `message_unread_id` FOREIGN KEY (`message_id`) REFERENCES `Message` (`message_id`) ON DELETE CASCADE ON UPDATE CASCADE;
COMMIT;


/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
