const token = require('express').Router();
const pool = require('../../database.js');

// POST token - Store an InstanceID token for a user if it doesn't exist
token.post('/', async (request, response) => {
  let conn;
  try {
    response.set("Content-Type", "application/json");
    conn = await pool.getConnection();

    const data = [
      request.body.userID,
      request.body.token
    ];
    // We just insert the values and handle the errors
    const sql = `INSERT INTO Token (user_id, token) VALUES (?, ?)`;
    await conn.query(sql, data);

  } catch (err) {
    // Suppress error when user/token combo already exists, which will happen often
    // Of course, this means all other errors will be ignored too.
  } finally {
    response.json({"status":"OK"});
    if (conn) return conn.end();
  }
});

module.exports = token;
