import { LitElement, html, css } from 'lit-element';
import { SharedStyles } from './shared-styles.js';
import { addIcon, rejectIcon } from './my-icons.js';

class AthleteItem extends LitElement {

  static get properties() {
    return {
      firstname: { type: String },
      email: { type: String },
      lastname: { type: String }
    }
  }


  static get styles() {
    return [
      SharedStyles,
      css`
        :host {
          display: flex;
          flex-direction: column;
        }
        .user-choice {
          display: flex;
          flex-direction: row;
          align-items: center;
        }
        .user-email {
          color: var(--dark-sand-color);
        }
      `
    ];
  }

  render() {
    return html`

          <div class="user-name">
            ${this.firstname} ${this.lastname}
          </div>
          <div class="user-email">
            ${this.email}
          </div>
    `;
  }
}

window.customElements.define('athlete-item', AthleteItem);
