import '@vaadin/vaadin-dialog';
import { LitElement, html } from 'lit-element';
/**
 * Returns a bool. Has two buttons, left(btn1) and right(btn2)
 * @param {string} btn1
 * @param {string} btn2
 */

export const confirmationDialog = (btn1, btn2) => {
    html `
        <vaadin-dialog
            no-close-on-esc no-close-on-outside-click>
        </vaadin-dialog>
    `;

    let answer = false;
    customElements.whenDefined('vaadin-dialog').then(() => {
        const dialog = document.querySelector('vaadin-dialog');
        dialog.render = (root, dialog) => {
            // Check if there is a DOM generated with the previous renderer
            //call to update its content instead of recreation
            if (root.firstElementChild) {
                return;
            }
            const div = window.docuent.createElement('div');
            div.textContent = 'Sende melding';

            const br = window.document.createElement('br');

            const okButton = window.document.createElement('vaadin-button');
            okButton.setAttribute('theme', 'primary');
            okButton.textContent = btn1;
            okButton.setAttribute('style', 'margin-right: 1em');
            okButton.addEventListener('click', () => {
                answer = true;
            });

            const cancelButton = window.document.createElement('vaadin-button');
            cancelButton.textContent = btn2;
            cancelButton.addEventListener('click', () => {
                answer = false;
            });

            root.appendChild(div);
            root.appendChild(br);
            root.appendChild(okButton);
            root.appendChild(cancelButton)
        };
        document.querySelector('vaadin-button').addEventListener('click', () => {
            dialog.opened = true;
        });
    });
    return answer;
}
