import '@vaadin/vaadin-notification';
import { LitElement, html } from 'lit-element';
/**
 * PopUp message on screen.
 * Duration in ms.
 * Position: top-stretch, top-start, top-center, top-end, middle, bottom-start, bottom-center, bottom-end, bottom-stretch
 * @param {string} message
 * @param {string} duration
 * @param {string} position
 */

export const notificationPopUp = (message, duration, position) => {
    html`
        <vaadin-notification duration=${duration} position=${position}></vaadin-notification>
    `;

    const notification = document.querySelector('vaadin-notification');
    notification.open();
    notification.renderer = root => {
      root.textContent = message;
    };
}
