import { FETCH_BEGIN, FETCH_SUCCESS, FETCH_FAILURE } from '../actions/server-fetch.js';
import { LOGOUT } from '../actions/session.js';

const INITIAL_STATE = {
  loading: false,
  error: null,
  data: {}
};

const resources = (state = INITIAL_STATE, action) => {
  switch (action.type) {
    case FETCH_BEGIN:
      return {
        ...state,
        loading: true,
        error: null
      };
    case FETCH_SUCCESS:
      return {
        ...state,
        loading: false,
        data: action.payload.data
      };
    case FETCH_FAILURE:
      return {
        ...state,
        loading: false,
        error: action.payload.error,
        data: {}
      };
    case LOGOUT:  // Flush resources on logout
      return {
        ...state,
        loading: INITIAL_STATE.loading,
        error: INITIAL_STATE.error,
        data: INITIAL_STATE.data
      };
    default:
      return state;
  };
};

export default resources;
